commit 701193a7a6d3f3f345bf336e7ebc7d6fa1e0c5ac
Author: Richard Sandiford <richard.sandiford@arm.com>
Date:   Thu Aug 14 18:56:51 2025

    aarch64: Use VNx16BI for svrev_b* [PR121294]
    
    The previous patch for PR121294 handled svtrn1/2, svuzp1/2, and svzip1/2.
    This one extends it to handle svrev intrinsics, where the same kind of
    wrong code can be generated.
    
    gcc/
            PR target/121294
            * config/aarch64/aarch64.md (UNSPEC_REV_PRED): New unspec.
            * config/aarch64/aarch64-sve.md (@aarch64_sve_rev<mode>_acle)
            (*aarch64_sve_rev<mode>_acle): New patterns.
            * config/aarch64/aarch64-sve-builtins-base.cc
            (svrev_impl::expand): Use the new patterns for boolean svrev.
    
    gcc/testsuite/
            PR target/121294
            * gcc.target/aarch64/sve/acle/general/rev_2.c: New test.

diff --git a/gcc/config/aarch64/aarch64-sve-builtins-base.cc b/gcc/config/aarch64/aarch64-sve-builtins-base.cc
index b4396837c24..6eef545dd3f 100644
--- a/gcc/config/aarch64/aarch64-sve-builtins-base.cc
+++ b/gcc/config/aarch64/aarch64-sve-builtins-base.cc
@@ -2857,7 +2857,10 @@ public:
   rtx
   expand (function_expander &e) const override
   {
-    return e.use_exact_insn (code_for_aarch64_sve_rev (e.vector_mode (0)));
+    auto mode = e.vector_mode (0);
+    return e.use_exact_insn (e.type_suffix (0).bool_p
+			     ? code_for_aarch64_sve_rev_acle (mode)
+			     : code_for_aarch64_sve_rev (mode));
   }
 };
 
diff --git a/gcc/testsuite/gcc.target/aarch64/sve/acle/general/rev_2.c b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/rev_2.c
new file mode 100644
index 00000000000..3dc4eb92854
--- /dev/null
+++ b/gcc/testsuite/gcc.target/aarch64/sve/acle/general/rev_2.c
@@ -0,0 +1,27 @@
+/* { dg-do compile } */
+/* { dg-options "-O2" } */
+
+#include <arm_sve.h>
+
+svbool_t test1()
+{
+  return svrev_b16 (svptrue_b16 ());
+}
+
+svbool_t test2()
+{
+  return svrev_b32 (svptrue_b32 ());
+}
+
+svbool_t test3()
+{
+  return svrev_b64 (svptrue_b64 ());
+}
+
+/* { dg-final { scan-assembler {\tptrue\tp[0-7]\.h} } } */
+/* { dg-final { scan-assembler {\tptrue\tp[0-7]\.s} } } */
+/* { dg-final { scan-assembler {\tptrue\tp[0-7]\.d} } } */
+/* { dg-final { scan-assembler-not {\tptrue\tp[0-7]\.b} } } */
+/* { dg-final { scan-assembler {\trev\tp0\.h} } } */
+/* { dg-final { scan-assembler {\trev\tp0\.s} } } */
+/* { dg-final { scan-assembler {\trev\tp0\.d} } } */

